/**
 * 
  askeyboard.ino  Main sketch of "Hobo-nicola ASKeyboard" using Hobo-nicola keyboard and adapter library.
  Copyright (c) 2019 Takeshi Higasa
  
  This file is part of "Hobo-nicola keyboard and adapter library".

  "Hobo-nicola keyboard and adapter library" is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  "Hobo-nicola keyboard and adapter library" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with "Hobo-nicola keyboard and adapter library".  If not, see <http://www.gnu.org/licenses/>.
  
  askeyboard.ino included in hoboNicola Library 1.5.0.  Jul. 25, 2021
  
*/

#include "hobo_nicola.h"
#include "ASkeyboard.h"

class Askb_Hobo_Nicola : public HoboNicola {
public:
	virtual void nicola_led(bool on) { SET_KANA_LED(on); }
	virtual void toggle_nicola_led() { TOGGLE_KANA_LED(); }
	virtual void error_led(bool on) { SET_CXFR_LED(on); }

};

Askb_Hobo_Nicola askb_hobo_nicola;

class kbd_event : public keyboard_notify {
  public:
//    virtual void modifier_changed(uint8_t before, uint8_t after) { askb_hobo_nicola.modifier_change(before, after); }
    virtual void modifier_changed(uint8_t before, uint8_t after) {}
    virtual void raw_key_event(uint8_t key, bool released = false) {}
    virtual void key_pressed  (uint8_t key, uint8_t mod) { askb_hobo_nicola.key_event(key, true);  }
    virtual void key_released  (uint8_t key, uint8_t mod) { askb_hobo_nicola.key_event(key, false); };
    virtual void key_released_all () {}
		virtual void enter_setup() { askb_hobo_nicola.enter_setup_mode(); }
};

ASkeyboard* askb = ASkeyboard::getInstance();

void setup() {
	HoboNicola::init_hobo_nicola(&askb_hobo_nicola);
	askb_hobo_nicola.set_oyayubi_keys(ASKB_LEFT_OYAYUBI, ASKB_RIGHT_OYAYUBI);
  askb->begin(new kbd_event);
}

void loop() {
  askb->task(HoboNicola::get_hid_led_state());
  askb_hobo_nicola.idle(); 
  askb_hobo_nicola.set_disable_nicola(askb->is_nicola_disabled());	// JIS mode.
  askb_hobo_nicola.has_dedicated_oyakeys(askb->dedicated_oyayubi());
  askb->setup_led(askb_hobo_nicola.is_setup_mode());
}